Project (Gradle API 2.14.1)
Date: 2016-07-18

Package: org.gradle.plugins.ide.idea.model

## [Java] Class Project

- org.gradle.plugins.ide.idea.model.Project

- Represents the customizable elements of an ipr (via XML hooks everything of the ipr is customizable).

- - ### Constructor Summary

    Constructors
    Constructor and description
    `Project (org.gradle.internal.xml.XmlTransformer xmlTransformer, Object pathFactory)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `configure(List<IdeaModule> modules, String jdkName, IdeaLanguageLevel languageLevel, JavaVersion bytecodeVersion, Collection<String> wildcards, Collection<ProjectLibrary> projectLibraries, String vcs)`
    `boolean` | `equals(Object o)`
    `protected String` | `getDefaultResourceName()`
    `Jdk` | `getJdk()` Represent the jdk information of the project java sdk.
    `Set<Path>` | `getModulePaths()` A set of Path instances pointing to the modules contained in the ipr.
    `Set<ProjectLibrary>` | `getProjectLibraries()` The project-level libraries of the IDEA project.
    `String` | `getVcs()` The vcs used by the project.
    `Set<String>` | `getWildcards()` A set of wildcard string to be included/excluded from the resources.
    `int` | `hashCode()`
    `protected void` | `load(groovy.util.Node xml)`
    `void` | `setJdk(Jdk jdk)`
    `void` | `setModulePaths(Set<Path> modulePaths)`
    `void` | `setProjectLibraries(Set<ProjectLibrary> projectLibraries)`
    `void` | `setVcs(String vcs)`
    `void` | `setWildcards(Set<String> wildcards)`
    `protected void` | `store(groovy.util.Node xml)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject` | `org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#load(java.io.InputStream), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#store(java.io.OutputStream), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#getXml(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#findFirstChildNamed(groovy.util.Node, java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#findFirstChildWithAttributeValue(groovy.util.Node, java.lang.String, java.lang.String, java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#findOrCreateFirstChildNamed(groovy.util.Node, java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#findOrCreateFirstChildWithAttributeValue(groovy.util.Node, java.lang.String, java.lang.String, java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#transformAction(groovy.lang.Closure), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#load(java.io.File), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#store(java.io.File), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#loadDefaults(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#setProperty(java.lang.String, java.lang.Object), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#getProperty(java.lang.String), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#invokeMethod(java.lang.String, java.lang.Object), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#setMetaClass(groovy.lang.MetaClass), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#getMetaClass(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#wait(long, int), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#wait(long), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#wait(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#equals(java.lang.Object), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#toString(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#hashCode(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#getClass(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#notify(), org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject#notifyAll()`
    `class org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject` | `org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#load(java.io.InputStream), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#load(java.io.File), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#store(java.io.File), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#store(java.io.OutputStream), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#loadDefaults(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#setProperty(java.lang.String, java.lang.Object), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#getProperty(java.lang.String), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#invokeMethod(java.lang.String, java.lang.Object), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#setMetaClass(groovy.lang.MetaClass), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#getMetaClass(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#wait(long, int), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#wait(long), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#wait(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#equals(java.lang.Object), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#toString(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#hashCode(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#getClass(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#notify(), org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject#notifyAll()`

- - ### Constructor Detail

    - #### public Project(org.gradle.internal.xml.XmlTransformer xmlTransformer, Object pathFactory)

  - ### Method Detail

    - #### public void configure(List<IdeaModule> modules, String jdkName, IdeaLanguageLevel languageLevel, JavaVersion bytecodeVersion, Collection<String> wildcards, Collection<ProjectLibrary> projectLibraries, String vcs)

    - #### @Override public boolean equals(Object o)

    - #### @Override protected String getDefaultResourceName()

    - #### public Jdk getJdk()

      Represent the jdk information of the project java sdk.

    - #### public Set<Path> getModulePaths()

      A set of Path instances pointing to the modules contained in the ipr.

    - #### @Incubating public Set<ProjectLibrary> getProjectLibraries()

      The project-level libraries of the IDEA project.

    - #### @Incubating public String getVcs()

      The vcs used by the project.

    - #### public Set<String> getWildcards()

      A set of wildcard string to be included/excluded from the resources.

    - #### @Override public int hashCode()

    - #### @Override protected void load(groovy.util.Node xml)

    - #### public void setJdk(Jdk jdk)

    - #### public void setModulePaths(Set<Path> modulePaths)

    - #### @Incubating public void setProjectLibraries(Set<ProjectLibrary> projectLibraries)

    - #### @Incubating public void setVcs(String vcs)

    - #### public void setWildcards(Set<String> wildcards)

    - #### @Override protected void store(groovy.util.Node xml)